// Functions for sending e-mail (one of 2 ways to send user feedback
// for CGIs...)
#ifndef RH_MAIL_H
#define RH_MAIL_H 1

#include <string>
#include <list>
#include <iostream>
#include <socket.h>

typedef list<string> stringlist;
typedef list<string>::iterator stringlist_it;

/** Class for sending e-mail
  */
class mail {
public:	
	/** Constructor - create a mail...
	  * @param subj subject of message
	  * @param msg content of message
	  * @param rcpt recipients of this message
	  * @param frm sender of message (default: autodetect [getuid()@gethostname()])
	  * @param now If true, send the message immediately
	  * @param srv SMTP server (default: localhost)
	  */
	mail(string subj, string msg, stringlist rcpt, string frm="", bool now=false, string srv="localhost");

	/** Constructor - create a mail...
	  * @param subj subject of message
	  * @param msg content of message
	  * @param rcpt recipient of this message
	  * @param frm sender of message (default: autodetect [getuid()@gethostname()])
	  * @param now If true, send the message immediately
	  * @param srv SMTP server (default: localhost)
	  */
	mail(string subj, string msg, string rcpt="", string frm="", bool now=false, string srv="localhost");
	~mail();

	/** Add a recipient
	  * @param addr Address of new recipient
	  */
	void to(string addr);

	/** Send the message
	  * @return 0 on success
	  */
	int send();
private:
	string subject;
	string message;
	string from;
	stringlist recipients;
	string server;
};

#endif
